/*eslint no-unused-vars: 0*/
'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x2, _x3, _x4) { var _again = true; _function: while (_again) { var object = _x2, property = _x3, receiver = _x4; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x2 = parent; _x3 = property; _x4 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _history = require('./history');

var _history2 = _interopRequireDefault(_history);

var _utils = require('./utils');

var _select = require('./select');

var _select2 = _interopRequireDefault(_select);

var _pencil = require('./pencil');

var _pencil2 = _interopRequireDefault(_pencil);

var _line = require('./line');

var _line2 = _interopRequireDefault(_line);

var _rectangle = require('./rectangle');

var _rectangle2 = _interopRequireDefault(_rectangle);

var _circle = require('./circle');

var _circle2 = _interopRequireDefault(_circle);

var _tools = require('./tools');

var _tools2 = _interopRequireDefault(_tools);

var fabric = require('fabric').fabric;

/**
 * Sketch Tool based on FabricJS for React Applications
 */

var SketchField = (function (_React$Component) {
    _inherits(SketchField, _React$Component);

    _createClass(SketchField, null, [{
        key: 'propTypes',
        value: {
            // the color of the line
            lineColor: _react2['default'].PropTypes.string,
            // The width of the line
            lineWidth: _react2['default'].PropTypes.number,
            // the fill color of the shape when applicable
            fillColor: _react2['default'].PropTypes.string,
            // the opacity of the object
            opacity: _react2['default'].PropTypes.number,
            // number of undo/redo steps to maintain
            undoSteps: _react2['default'].PropTypes.number,
            // The tool to use, can be pencil, rectangle, circle, brush;
            tool: _react2['default'].PropTypes.string,
            // image format when calling toDataURL
            imageFormat: _react2['default'].PropTypes.string,
            // Scale the drawing when we resize the canvas
            scaleOnResize: _react2['default'].PropTypes.bool,
            // Default initial data
            defaultData: _react2['default'].PropTypes.object,
            // Type of initial data
            defaultDataType: _react2['default'].PropTypes.oneOf(['json', 'url'])
        },
        enumerable: true
    }, {
        key: 'defaultProps',
        value: {
            lineColor: 'black',
            lineWidth: 1,
            fillColor: 'transparent',
            opacity: 1.0,
            undoSteps: 15,
            scaleOnResize: true,
            tool: _tools2['default'].Pencil,
            defaultDataType: 'json'
        },
        enumerable: true
    }]);

    function SketchField(props, context) {
        _classCallCheck(this, SketchField);

        _get(Object.getPrototypeOf(SketchField.prototype), 'constructor', this).call(this, props, context);
        this._resize = this._resize.bind(this);
        this._initTools = this._initTools.bind(this);
        this._onMouseUp = this._onMouseUp.bind(this);
        this._onMouseOut = this._onMouseOut.bind(this);
        this._onMouseDown = this._onMouseDown.bind(this);
        this._onMouseMove = this._onMouseMove.bind(this);
        this._onObjectAdded = this._onObjectAdded.bind(this);
        this._onObjectRemoved = this._onObjectRemoved.bind(this);
        this._onObjectModified = this._onObjectModified.bind(this);
        this.state = {
            parentWidth: 10,
            action: true
        };
    }

    _createClass(SketchField, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this = this;

            var _props = this.props;
            var tool = _props.tool;
            var undoSteps = _props.undoSteps;
            var defaultData = _props.defaultData;
            var defaultDataType = _props.defaultDataType;

            var canvas = this._fc = new fabric.Canvas(this._canvas.id);
            this._initTools(canvas);

            var selectedTool = this._tools[tool];
            selectedTool.configureCanvas(this.props);

            // Control resize
            window.addEventListener('resize', this._resize, false);
            this._resize(null);

            // Initialize History, with maximum number of undo steps
            this._history = new _history2['default'](undoSteps);

            // Events binding
            canvas.on('object:added', this._onObjectAdded);
            canvas.on('object:modified', this._onObjectModified);
            canvas.on('object:removed', this._onObjectRemoved);
            canvas.on('mouse:down', this._onMouseDown);
            canvas.on('mouse:move', this._onMouseMove);
            canvas.on('mouse:up', this._onMouseUp);
            canvas.on('mouse:out', this._onMouseOut);

            // initialize canvas with default data
            setTimeout(function () {
                if (defaultData) {
                    if ('json' === defaultDataType) {
                        _this.fromJson(defaultData);
                    }
                    if ('url' === defaultDataType) {
                        _this.fromDataURL(defaultData);
                    }
                }
            }, 100);
        }
    }, {
        key: '_initTools',
        value: function _initTools(fabricCanvas) {
            this._tools = {};
            this._tools[_tools2['default'].Select] = new _select2['default'](fabricCanvas);
            this._tools[_tools2['default'].Pencil] = new _pencil2['default'](fabricCanvas);
            this._tools[_tools2['default'].Line] = new _line2['default'](fabricCanvas);
            this._tools[_tools2['default'].Rectangle] = new _rectangle2['default'](fabricCanvas);
            this._tools[_tools2['default'].Circle] = new _circle2['default'](fabricCanvas);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('resize', this._resize);
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(props) {
            var tool = this._tools[props.tool] || this._tools['pencil'];
            tool.configureCanvas(props);
        }
    }, {
        key: '_onObjectAdded',
        value: function _onObjectAdded(e) {
            if (!this.state.action) {
                this.setState({ action: true });
                return;
            }
            var obj = e.target;
            obj.version = 1;
            var state = JSON.stringify(obj.originalState);
            // object, previous state, current state
            this._history.keep([obj, state, state]);
        }
    }, {
        key: '_onObjectModified',
        value: function _onObjectModified(e) {
            var obj = e.target;
            obj.version += 1;
            var prevState = JSON.stringify(obj.originalState);
            obj.saveState();
            var currState = JSON.stringify(obj.originalState);
            this._history.keep([obj, prevState, currState]);
        }
    }, {
        key: '_onObjectRemoved',
        value: function _onObjectRemoved(e) {
            var obj = e.target;
            obj.version = 0;
        }
    }, {
        key: '_onMouseDown',
        value: function _onMouseDown(e) {
            var tool = this._tools[this.props.tool];
            if (tool) {
                tool.doMouseDown(e);
            }
        }
    }, {
        key: '_onMouseMove',
        value: function _onMouseMove(e) {
            var tool = this._tools[this.props.tool];
            if (tool) {
                tool.doMouseMove(e);
            }
        }
    }, {
        key: '_onMouseUp',
        value: function _onMouseUp(e) {
            var tool = this._tools[this.props.tool];
            if (tool) {
                tool.doMouseUp(e);
            }
            if (this.props.onChange) {
                this.props.onChange(event.e);
            }
        }
    }, {
        key: '_onMouseOut',
        value: function _onMouseOut(e) {
            var tool = this._tools[this.props.tool];
            if (tool) {
                tool.doMouseOut(e);
            }
            if (this.props.onChange) {
                this.props.onChange(event.e);
            }
        }

        /**
         * Track the resize of the window and update our state
         *
         * @param e the resize event
         * @private
         */
    }, {
        key: '_resize',
        value: function _resize(e) {
            if (e) {
                e.preventDefault();
            }
            // if disabled then do not perform the resize
            if (!this.props.scaleOnResize) return;
            var canvas = this._fc;
            var domNode = _reactDom2['default'].findDOMNode(this);
            var width = domNode.offsetWidth;
            var height = domNode.offsetHeight;
            var prevWidth = canvas.getWidth();
            var prevHeight = canvas.getHeight();
            var wfactor = width / prevWidth;
            var hfactor = height / prevHeight;
            canvas.setWidth(width);
            canvas.setHeight(height);
            if (canvas.backgroundImage) {
                // Need to scale background images as well
                var bi = canvas.backgroundImage;
                bi.width = bi.width * wfactor;
                bi.height = bi.height * hfactor;
            }
            var objects = canvas.getObjects();
            for (var i in objects) {
                var obj = objects[i];
                var scaleX = obj.scaleX;
                var scaleY = obj.scaleY;
                var left = obj.left;
                var _top = obj.top;
                var tempScaleX = scaleX * wfactor;
                var tempScaleY = scaleY * hfactor;
                var tempLeft = left * wfactor;
                var tempTop = _top * hfactor;
                obj.scaleX = tempScaleX;
                obj.scaleY = tempScaleY;
                obj.left = tempLeft;
                obj.top = tempTop;
                obj.setCoords();
            }
            this.setState({
                parentWidth: width,
                parentHeight: height
            });
            canvas.renderAll();
            canvas.calcOffset();
        }

        /**
         * Perform an undo operation on canvas, if it cannot undo it will leave the canvas intact
         */
    }, {
        key: 'undo',
        value: function undo() {
            var history = this._history;

            var _history$getCurrent = history.getCurrent();

            var _history$getCurrent2 = _slicedToArray(_history$getCurrent, 3);

            var obj = _history$getCurrent2[0];
            var prevState = _history$getCurrent2[1];
            var currState = _history$getCurrent2[2];

            history.undo();
            if (obj.version === 1) {
                obj.remove();
            } else {
                obj.setOptions(JSON.parse(prevState));
                obj.setCoords();
                obj.version -= 1;
                this._fc.renderAll();
            }
        }

        /**
         * Perform a redo operation on canvas, if it cannot redo it will leave the canvas intact
         */
    }, {
        key: 'redo',
        value: function redo() {
            var _this2 = this;

            var history = this._history;
            if (history.canRedo()) {
                (function () {
                    var canvas = _this2._fc;
                    //noinspection Eslint

                    var _history$redo = history.redo();

                    var _history$redo2 = _slicedToArray(_history$redo, 3);

                    var obj = _history$redo2[0];
                    var prevState = _history$redo2[1];
                    var currState = _history$redo2[2];

                    if (obj.version === 0) {
                        _this2.setState({ action: false }, function () {
                            canvas.add(obj);
                            obj.version = 1;
                        });
                    } else {
                        obj.version += 1;
                        obj.setOptions(JSON.parse(currState));
                    }
                    obj.setCoords();
                    canvas.renderAll();
                })();
            }
        }

        /**
         * Delegation method to check if we can perform an undo Operation, useful to disable/enable possible buttons
         *
         * @returns {*} true if we can undo otherwise false
         */
    }, {
        key: 'canUndo',
        value: function canUndo() {
            return this._history.canUndo();
        }

        /**
         * Delegation method to check if we can perform a redo Operation, useful to disable/enable possible buttons
         *
         * @returns {*} true if we can redo otherwise false
         */
    }, {
        key: 'canRedo',
        value: function canRedo() {
            return this._history.canRedo();
        }

        /**
         * Exports canvas element to a dataurl image. Note that when multiplier is used, cropping is scaled appropriately
         *
         * Available Options are
         * <table style="width:100%">
         *
         * <tr><td><b>Name</b></td><td><b>Type</b></td><td><b>Argument</b></td><td><b>Default</b></td><td><b>Description</b></td></tr>
         * <tr><td>format</td> <td>String</td> <td><optional></td><td>png</td><td>The format of the output image. Either "jpeg" or "png"</td></tr>
         * <tr><td>quality</td><td>Number</td><td><optional></td><td>1</td><td>Quality level (0..1). Only used for jpeg.</td></tr>
         * <tr><td>multiplier</td><td>Number</td><td><optional></td><td>1</td><td>Multiplier to scale by</td></tr>
         * <tr><td>left</td><td>Number</td><td><optional></td><td></td><td>Cropping left offset. Introduced in v1.2.14</td></tr>
         * <tr><td>top</td><td>Number</td><td><optional></td><td></td><td>Cropping top offset. Introduced in v1.2.14</td></tr>
         * <tr><td>width</td><td>Number</td><td><optional></td><td></td><td>Cropping width. Introduced in v1.2.14</td></tr>
         * <tr><td>height</td><td>Number</td><td><optional></td><td></td><td>Cropping height. Introduced in v1.2.14</td></tr>
         *
         * </table>
         *
         * @returns {String} URL containing a representation of the object in the format specified by options.format
         */
    }, {
        key: 'toDataURL',
        value: function toDataURL(options) {
            return this._fc.toDataURL(options);
        }

        /**
         * Returns JSON representation of canvas
         *
         * @param propertiesToInclude Array    <optional>
         Any properties that you might want to additionally include in the output
         * @returns {string} JSON string
         */
    }, {
        key: 'toJSON',
        value: function toJSON(propertiesToInclude) {
            return this._fc.toJSON(propertiesToInclude);
        }

        /**
         * Populates canvas with data from the specified JSON.
         *
         * JSON format must conform to the one of fabric.Canvas#toDatalessJSON
         *
         * @param json JSON string or object
         * @param callback Callback, invoked when json is parsed and corresponding objects (e.g: fabric.Image) are initialized
         * @param reviver Method for further parsing of JSON elements, called after each fabric object created.
          */
    }, {
        key: 'fromJson',
        value: function fromJson(json) {
            var canvas = this._fc;
            canvas.loadFromJSON(json, function () {
                return canvas.renderAll();
            });
        }

        /**
         * This method will create an image and load the given url data
         *
         * @param data URL data to load as image
         * @param options options to be applied to image <optional>
         */
    }, {
        key: 'fromDataURL',
        value: function fromDataURL(data) {
            var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

            var canvas = this._fc;
            var img = new Image();
            img.src = data;
            img.onload = function () {
                return canvas.add(new fabric.Image(img, options));
            };
        }

        /**
         * Clear the content of the canvas, this will also keep the last version of it to history
         */
    }, {
        key: 'clear',
        value: function clear() {
            this._fc.clear();
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var _props2 = this.props;
            var className = _props2.className;
            var disabled = _props2.disabled;
            var style = _props2.style;
            var onChange = _props2.onChange;
            var width = _props2.width;
            var height = _props2.height;

            var other = _objectWithoutProperties(_props2, ['className', 'disabled', 'style', 'onChange', 'width', 'height']);

            return _react2['default'].createElement(
                'div',
                { className: className, style: style },
                _react2['default'].createElement(
                    'canvas',
                    {
                        id: (0, _utils.uuid4)(),
                        height: height || 512,
                        ref: function (c) {
                            return _this3._canvas = c;
                        },
                        width: width || this.state.parentWidth },
                    'Sorry, Canvas HTML5 element is not supported by your browser :('
                )
            );
        }
    }]);

    return SketchField;
})(_react2['default'].Component);

exports['default'] = SketchField;
module.exports = exports['default'];